package systeminfo

import "github.com/mailru/easyjson"

// Code generated by chromedp-gen. DO NOT EDIT.

// GPUDevice describes a single graphics processor (GPU).
type GPUDevice struct {
	VendorID     float64 `json:"vendorId"`     // PCI ID of the GPU vendor, if available; 0 otherwise.
	DeviceID     float64 `json:"deviceId"`     // PCI ID of the GPU device, if available; 0 otherwise.
	VendorString string  `json:"vendorString"` // String description of the GPU vendor, if the PCI ID is not available.
	DeviceString string  `json:"deviceString"` // String description of the GPU device, if the PCI ID is not available.
}

// GPUInfo provides information about the GPU(s) on the system.
type GPUInfo struct {
	Devices              []*GPUDevice        `json:"devices"` // The graphics devices on the system. Element 0 is the primary GPU.
	AuxAttributes        easyjson.RawMessage `json:"auxAttributes,omitempty"`
	FeatureStatus        easyjson.RawMessage `json:"featureStatus,omitempty"`
	DriverBugWorkarounds []string            `json:"driverBugWorkarounds"` // An optional array of GPU driver bug workarounds.
}
